def merge_array(arr1, arr2):
    arr3 = []
    i = 0
    j = 0
    while i < len(arr1) and j < len(arr2):
        if arr1[i] < arr2[j]:
            arr3.append(arr1[i])
            i += 1
        else:
            arr3.append(arr2[j])
            j += 1

    while i < len(arr1):
        arr3.append(arr1[i])
        i += 1

    while j < len(arr2):
        arr3.append(arr2[j])
        j += 1

    return arr3


if __name__ == '__main__':
    a1 = [2, 7, 8, 11]
    a2 = [1, 3, 4, 5, 6, 9, 10]
    print merge_array(a1, a2)  # [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
    print merge_array(a2, a1)  # [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]


    a1 = [1, 2, 3, 4, 5]
    a2 = [6, 7, 8]

    print a1 + a2  # [1, 2, 3, 4, 5, 6, 7, 8]
    a1.extend(a2)
    print a1  # [1, 2, 3, 4, 5, 6, 7, 8]

    a1 = [1, 4, 6]
    a2 = [3, 2, 5, 7]
    print a1 + a2   # [1, 4, 6, 3, 2, 5, 7]


"""
C++
// Merge arr1[0..n1-1] and arr2[0..n2-1] into
// arr3[0..n1+n2-1]
void mergeArrays(int arr1[], int arr2[], int n1,
                             int n2, int arr3[])
{
    int i = 0, j = 0, k = 0;
 
    // Traverse both array
    while (i<n1 && j <n2)
    {
        // Check if current element of first
        // array is smaller than current element
        // of second array. If yes, store first
        // array element and increment first array
        // index. Otherwise do same with second array
        if (arr1[i] < arr2[j])
            arr3[k++] = arr1[i++];
        else
            arr3[k++] = arr2[j++];
    }
 
    // Store remaining elements of first array
    while (i < n1)
        arr3[k++] = arr1[i++];
 
    // Store remaining elements of second array
    while (j < n2)
        arr3[k++] = arr2[j++];
}
 
// Driver code
int main()
{
    int arr1[] = {1, 3, 5, 7};
    int n1 = sizeof(arr1) / sizeof(arr1[0]);
 
    int arr2[] = {2, 4, 6, 8};
    int n2 = sizeof(arr2) / sizeof(arr2[0]);
 
    int arr3[n1+n2];
    mergeArrays(arr1, arr2, n1, n2, arr3);
 
    cout << "Array after merging" <<endl;
    for (int i=0; i < n1+n2; i++)
        cout << arr3[i] << " ";
 
    return 0;
}

"""